#lang racket

;;;; 3. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 1.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - funkcionálne programovanie: operátor abstrakcie,
;;;; - karteziánsky súčin,
;;;; - základné operácie na zoznamoch,
;;;; - aplikácie zoznamov,
;;;; - stromy ako zovšeobecnené zoznamy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 6.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Funkcionálne programovanie.

;;; Sekcia. Konštrukcia programu s pomocou operátora abstrakcie.

;; Príklad. Nasledujúci komponent obsahuje konštrukciu programu s pomocou
;; špeciálnej formy λ (tiež λ-operátor, operátor abstrakcie). Program počíta
;; štvorec daného čísla.

(define square (λ (x) (* x x)))

;; (square 5)
;; (query square 0 10)

;; Tá istá konštrukcia s pomocou špeciálnej formy lambda.

(define square2 (lambda (x) (* x x)))

;; (square2 5)
;; (query square2 0 10)

;; Úloha. Zostrojte pomocou λ program, ktorý pre dané číslo vypočíta jeho
;; tretiu mocninu.

(define cube ...)

;; (cube 5)
;; (query cube 0 10)

;; Úloha. Zostrojte pomocou λ program, ktorý pre dané dve čísla vypočíta súčet
;; ich štvorcov. 

(define sum-of-squares (λ (x y) ...))

;; (sum-of-squares 3 4)
;; (query (λ (y) (sum-of-squares 1 y)) 0 10)

;; Úloha. Zostrojte pomocou λ program pre identickú funkciu:
;;   identity(x) = x

(define identity ...)

;; (identity 5)
;; (query identity 0 10)

;; Úloha. Zostrojte pomocou λ program pre konštantnú funkciu zero:
;;   zero(x) = 0

(define zero ...)

;; (zero 5)
;; (query zero 0 10)

;; Úloha. Zostrojte pomocou λ program pre konštantnú funkciu one:
;;   one(x) = 1

(define one ...)

;; (one 5)
;; (query one 0 10)

;; Úloha. Zostrojte pomocou λ program pre funkciu nasledovníka:
;;   succ(x) = x+1

(define succ ...)

;; (succ 5)
;; (query succ 0 10)

;; Úloha. Zostrojte program pre funkcionál compose, ktorý má túto vlastnosť:
;;   compose(f,g)(x) = g f(x)

(define (compose f g) ...)

;; (query (compose square succ) 0 10)
;; (query (compose succ square) 0 10)

;; Úloha. Zostrojte program pre funkcionál param, ktorý má túto vlastnosť:
;;   param(f,x)(y) = f(x,y)

(define (param f x) ...)

;; (query (param * 2) 0 10)

;; (1 bod)
;; Úloha. Zostrojte program pre funkcionál iter, ktorý má túto vlastnosť: 
;;   iter(f,n)(x) = f f ... f(x)
;; Funkcia f sa tu n-krát aplikuje na vstup x. V definícii nepoužívajte
;; funkcionál iter(f,n,x) z minulého cvičenia.
;;   Návod. Funkcionál definujte primitívnou rekurziou s pomocou compose.

(define (iter f n) ...)

;; (iter succ 2)
;; ((iter succ 2) 3)
;; (query (λ (x) ((iter succ 2) x)) 0 10)
