#lang racket

;;;; 3. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 1.3.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - funkcionálne programovanie: operátor abstrakcie,
;;;; - karteziánsky súčin,
;;;; - základné operácie na zoznamoch,
;;;; - aplikácie zoznamov,
;;;; - stromy ako zovšeobecnené zoznamy.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 3
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 2
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0
;;;; Odovzdať do 6.3.2016 (nedeľa).

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define identity (λ (x) x))
(define zero (λ (x) 0))
(define one (λ (x) 1))
(define succ (λ (x) (+ x 1)))
(define singleton (λ (x) (list x)))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;; (define nil null)

;;; Kapitola. Stromy.

;;; Sekcia. Stromy ako zovšeobecnené zoznamy.

;; Príklad. Nasledujúci komponent obsahuje definiciu stromov pomocou
;; zovšeobecnených zoznamov.

(define (tree? t)
  (define (forest? ts)
    (or (null? ts)
        (and (pair? ts)
             (tree? (car ts))
             (forest? (cdr ts)))))
  (or (number? t)
      (and (pair? t)
           (tree? (car t))
           (forest? (cdr t)))))

;; (tree? 1)
;; (tree? null)
;; (tree? (list 1 2 3))
;; (tree? (list 1 null 3))
;; (tree? (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý spočíta počet listov v strome.

(define (count-leaves t) ...)

;; (count-leaves 1)
;; (count-leaves (list 1 2 3))
;; (count-leaves (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý spočíta počet (vnútorných) uzlov v strome.

(define (count-nodes t) ...)

;; (count-nodes 1)
;; (count-nodes (list 1 2 3))
;; (count-nodes (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý počíta výšku (hĺbku) stromu.

(define (height t) ...)

;; (height 1)
;; (height (list 1 2 3))
;; (height (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý vráti súčet všetkých listov v strome.

(define (sum-leaves t) ...)

;; (sum-leaves 1)
;; (sum-leaves (list 1 2 3))
;; (sum-leaves (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý vráti zoznam všetkých listov v strome.

(define (fringes t) ...)

;; (fringes 1)
;; (fringes (list 1 2 3))
;; (fringes (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program, ktorý vytvorí zrkadlový obraz vstupného stromu.

(define (reflect t) ...)

;; (reflect 1)
;; (reflect (list 1 2 3))
;; (reflect (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; Úloha. Zostrojte program pre funkcionál
;;   accumulate(tree,leaf-value,forest-value,combiner,null-value),
;; ktorý univerzálne akumuluje hodnoty daného rozsahu pre strom tree:
;; - leaf-value je funkcia aplikujúca sa na jednotlivé listy stromu,
;; - forest-value je funkcia aplikujúca sa na výsledok operácie combiner,
;; - combiner je akumulujúca funkcia aplikujúca sa na les,
;; - null je neutrálny prvok vzhľadom na combiner.

(define (accumulate tree leaf-value forest-value combiner null-value) ...)

;; (3 body)
;; Úloha. Definujte tieto funkcie z predošlých príkladov pomocou accumulate.

(define (count-leaves2 t) ...)
(define (count-nodes2 t) ...)
(define (height2 t) ...)
(define (sum-leaves2 t) ...)
(define (fringes2 t) ...)
(define (reflect2 t) ...)

;; (count-leaves2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))
;; (count-nodes2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))
;; (height2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))
;; (sum-leaves2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))
;; (fringes2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))
;; (reflect2 (list (list 1 2 3) (list 4 (list 5 6) 7 (list 8))))

;; (prémia 2 body)
;; Úloha. Zostrojte program, ktorý nahradí listy daného stromu číslami 1,2,3,...
;; v tomto poradí.

(define (numbering t1) ...)

;; (numbering 2)
;; (numbering (list 2 3 5))
;; (numbering (list (list 2 3 5) (list 7 (list 11 13) 17 (list 19))))
